#!/bin/sh
# BLURB gpl
# 
#                            Coda File System
#                               Release 5
# 
#           Copyright (c) 1987-1999 Carnegie Mellon University
#                   Additional copyrights listed below
# 
# This  code  is  distributed "AS IS" without warranty of any kind under
# the terms of the GNU General Public Licence Version 2, as shown in the
# file  LICENSE.  The  technical and financial  contributors to Coda are
# listed in the file CREDITS.
# 
#                         Additional copyrights
#                            none currently
# 
#*/

#
# Configuration
#
prefix=/usr/local
conf=/usr/local/etc/rc.d/coda/server.conf
if [ -f ${conf} ] ; then
  . ${conf}
fi

if [ x${vicedir} = x ] ; then
  vicedir=/vice
fi

THISHOST=`hostname | tr A-Z a-z`
REMOTE=${vicedir}/vol/remote

PATH=/sbin:/usr/sbin:$PATH
export PATH
cd ${vicedir}/vol/remote
SERVERS=""

# Get the locally generated ${vicedir}/vol/VolumeList from 
#  - all servers (if argc = 1)
#  - the listed servers (if argc > 1) 

if [ $#  = 0 ]; then
	SERVERS=`awk '{ print $1 }' ${vicedir}/db/servers`
else
    for i in $* ; do
        NEWSERVER=`awk '{ print $1 }' ${vicedir}/db/servers | grep $i `
	SERVERS="$NEWSERVER $SERVERS"
    done
fi

echo "Fetching ${vicedir}/vol/Volumelist from servers:"

for server in $SERVERS
do 
    updatefetch -h ${server} -r ${vicedir}/vol/VolumeList -l \
	${REMOTE}/${server}.list.new

    if [ -r ${REMOTE}/${server}.list.new ]; then
        mv ${REMOTE}/${server}.list.new ${REMOTE}/${server}.list
	echo " $server - success"
    else 
	echo " $server - FAILED, check if updatesrv is running"
    fi
done

# Make on big list called composite
cd ${REMOTE}; cat *.list> ../BigVolumeList

# Make a new vldb from the list
volutil makevldb  ${vicedir}/vol/BigVolumeList
